//+------------------------------------------------------------------+
//|                                                 e-NightTrade.mq4 |
//|                                             . aka KimIV |
//|                                              http://www.kimiv.ru |
//|                                                                  |
//|  06.02.2006   .                                    |
//+------------------------------------------------------------------+
#property copyright "  . aka KimIV"
#property link      "http://www.kimiv.ru"

//-------    --------------------------------
extern string _Parameters_Trade = "-----  ";
extern int  nDayOfWeek    = 1;      //   
extern int  HourOpenPos   = 23;     //   
extern int  MinuteOpenPos = 0;      //   
extern int  DepthHistory  = 14;     //   
extern int  RangeCutOff   = 19;     //  
extern int  StopLoss      = 68;     //  
extern int  TakeProfit    = 25;     //  
extern bool UseClosePos   = True;   //   
extern int  HourClosePos  = 3;      //   

//----    -------------------------------
double Lots        = 0.1;
int    Slippage    = 3;
int    MAGIC       = 20060206;
color  clOpenBuy   = LightBlue;
color  clOpenSell  = LightCoral;
color  clCloseBuy  = Blue;
color  clCloseSell = Red;


//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
void start() {
  if (DayOfWeek()==nDayOfWeek && Hour()==HourOpenPos
  && Minute()>=MinuteOpenPos && Minute()<=MinuteOpenPos+4) OpenPositions();

  if (UseClosePos && Hour()==HourClosePos) CloseAllPositions();
}

//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
void OpenPositions() {
  double ldStop=0, ldTake=0;
  int    bs=GetTradeSignal();

  if (!ExistPosition()) {
    if (bs>0) {
      if (StopLoss!=0) ldStop=Ask-StopLoss*Point;
      if (TakeProfit!=0) ldTake=Ask+TakeProfit*Point;
      OpenPosition(OP_BUY, ldStop, ldTake);
    }
    if (bs<0) {
      if (StopLoss!=0) ldStop=Bid+StopLoss*Point;
      if (TakeProfit!=0) ldTake=Bid-TakeProfit*Point;
      OpenPosition(OP_SELL, ldStop, ldTake);
    }
  }
}

//+------------------------------------------------------------------+
//|   :                                      |
//|    1 -                                                    |
//|    0 - ,                                           |
//|   -1 -                                                   |
//+------------------------------------------------------------------+
int GetTradeSignal() {
  int nb, bs=0;

  nb=Highest(NULL, 0, MODE_HIGH, DepthHistory, 1);
  if (High[nb]-Close[1]>RangeCutOff*Point) {
    bs=1;
  }
  nb=Lowest(NULL, 0, MODE_LOW, DepthHistory, 1);
  if (Close[1]-Low[nb]>RangeCutOff*Point) {
    bs=-1;
  }

  return(bs);
}

//+------------------------------------------------------------------+
//|                                |
//+------------------------------------------------------------------+
bool ExistPosition() {
  bool Exist=False;
  for (int i=0; i<OrdersTotal(); i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          Exist=True; break;
        }
      }
    }
  }
  return(Exist);
}

//+------------------------------------------------------------------+
//|                                                   |
//| :                                                       |
//|   op     -                                               |
//|   ldStop -                                            |
//|   ldTake -                                            |
//+------------------------------------------------------------------+
void OpenPosition(int op, double ldStop, double ldTake) {
  color  clOpen;
  double pp;

  if (op==OP_BUY) {
    clOpen=clOpenBuy; pp=Ask;
  } else {
    clOpen=clOpenSell; pp=Bid;
  }
  pp=NormalizeDouble(pp, Digits);
  OrderSend(Symbol(),op,Lots,pp,Slippage,ldStop,ldTake,"",MAGIC,0,clOpen);
}

//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+
void CloseAllPositions() {
  for (int i=OrdersTotal()-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) {
        if (OrderType()==OP_BUY) {
          OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, clCloseBuy);
        }
        if (OrderType()==OP_SELL) {
          OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, clCloseSell);
        }
      }
    }
  }
}
//+------------------------------------------------------------------+

